#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[])
{
    const char *synopsis = 
"~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n"
"                                                   14/12/2006,  V.Strom \n"
"                                                                        \n"
" usage:  add_sig_noise thresh < raw_wave > raw_wave                     \n"
"                                                                        \n"
"                                                                        \n"
" Add \"1\" into a sequence of $thresh \"0\"s in a raw wav file (short ints)\n"
" This stops a bug in HCopy corrupting the energy track of MFCC files.   \n"
"                                                                        \n"
" If environment variable REPORT_ADD_SIG_NOISE is set, every substitution\n"
" is reported.                                                           \n"
"                                                                        \n"
"~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n";

    int   thresh, cnt=0, zcnt=0, report=0, nsub=0;
    short sample;
 
 
    if(argc != 2)
    {   fprintf(stderr, synopsis);
        exit(1);
    }
    if(!sscanf(argv[1],"%d", &thresh))
    {   fprintf(stderr, synopsis);
        if(argv[1][0]=='-' && argv[1][1]=='h')
            exit(0);
        exit(1);
    }

    if(getenv("REPORT_ADD_SIG_NOISE"))
    {   report=1;
        fprintf(stderr,"add_sig_noise: substitute 0->1 at sample indices\n");
    }
 
     while(fread(&sample,sizeof(short),1,stdin))
     {   cnt++;
         if(sample==0)
             zcnt++;
         else
             zcnt=0;
         if(zcnt==thresh)
         {   sample++;
             zcnt=0;
             nsub++;
             if(report)
                 fprintf(stderr,"0->1 at %d\n",cnt);
         }
         fwrite(&sample,sizeof(short),1,stdout);
     }
     if(report && nsub==0)
        fprintf(stderr,"none\n");
}
